searchNodes=[{"ref":"Ace.Governor.html","title":"Ace.Governor","type":"module","doc":"A governor maintains servers ready to handle clients. A governor process starts with a reference to supervision that can start servers. It will then wait until the server has accepted a connection. Once it&#39;s server has accepted a connection the governor will start a new server."},{"ref":"Ace.Governor.html#child_spec/1","title":"Ace.Governor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Ace.Governor.html#start_link/2","title":"Ace.Governor.start_link/2","type":"function","doc":""},{"ref":"Ace.HTTP.Channel.html","title":"Ace.HTTP.Channel","type":"module","doc":"Reference to a single HTTP request/response exchange, within the context of a connection. With HTTP/2 a channel corresponds to a single stream. With HTTP/1.1 pipelining a single connection can support multiple channels. The channel struct provides a normalised structure regardless of which version of the protocol is used. A channel struct also contains all information about the connection. TODO consider calling this exchange instead of channel. TODO add functions like cleartext? http_version? transport_version that pull information from socket."},{"ref":"Ace.HTTP.Channel.html#ack/1","title":"Ace.HTTP.Channel.ack/1","type":"function","doc":"Send an acknowledgement that the Ace.HTTP.Worker has received a request part"},{"ref":"Ace.HTTP.Channel.html#monitor_endpoint/1","title":"Ace.HTTP.Channel.monitor_endpoint/1","type":"function","doc":"Monitor the process managing the local endpoint of the connection containing a channel."},{"ref":"Ace.HTTP.Channel.html#send/2","title":"Ace.HTTP.Channel.send/2","type":"function","doc":"Send a list of message parts over a HTTP channel."},{"ref":"Ace.HTTP.Channel.html#t:t/0","title":"Ace.HTTP.Channel.t/0","type":"type","doc":""},{"ref":"Ace.HTTP.Service.html","title":"Ace.HTTP.Service","type":"module","doc":"Run a Raxx.Server application for HTTP/1.x and HTTP/2 clients NOTE: Ace services are served over a secure transport layer TLS(SSL), therefore :cert + :key or :certfile + :keyfile are required options. Starting a service will start and manage a cohort of endpoint process. The number of awaiting endpoint processes is set by the :acceptors option. Each endpoint process manages communicate to a single connected client. Using HTTP/1.1 pipelining of HTTP/2 multiplexing one connection may be used for multiple HTTP exchanges. An HTTP exchange consisting of one request from the client and one response from the server. Each exchange is isolated in a dedicated worker process. Raxx specifies early abortion of an exchange can be achieved by causing the worker process to exit."},{"ref":"Ace.HTTP.Service.html#count_connections/1","title":"Ace.HTTP.Service.count_connections/1","type":"function","doc":"Returns a number of connected clients for a given service."},{"ref":"Ace.HTTP.Service.html#port/1","title":"Ace.HTTP.Service.port/1","type":"function","doc":"Fetch the port number of a running service. OS assigned ports: If an endpoint is started with port number 0 it will be assigned a port by the underlying system. This can be used to start many endpoints simultaneously. It can be useful running parallel tests."},{"ref":"Ace.HTTP.Service.html#start_link/2","title":"Ace.HTTP.Service.start_link/2","type":"function","doc":"Start a HTTP web service. Options :cleartext - Serve over TCP rather than TLS(ssl), will not support HTTP/2. :certfile - the certificate. :keyfile - the private key used to sign the certificate request. :cert - the certificate. :key - the private key used to sign the certificate request. :port - the port to run the server on. Defaults to port 8443. :name - name to register the spawned endpoint under. The supported values are the same as GenServers. :acceptors - The number of servers simultaneously waiting for a connection. Defaults to 100. :error_response - The response that Ace will send if a request handler crashes. Useful for setting custom headers, e.g. for CORS. Internal socket options can also be specified, most notably: :alpn_preferred_protocols - which protocols should be negotiated for the https traffic. Defaults to [&quot;h2&quot;, &quot;http/1.1&quot;] The additional options will be passed to :gen_tcp.listen/2 and :ssl.listen/2 as appropriate."},{"ref":"Ace.HTTP.Service.html#t:service/0","title":"Ace.HTTP.Service.service/0","type":"type","doc":"Process to manage a HTTP service. This process should be added to a supervision tree as a supervisor."},{"ref":"Ace.HTTP.Worker.html","title":"Ace.HTTP.Worker","type":"module","doc":"Run a Raxx application in isolation to handle a single HTTP exchange. The application consists of a behaviour module and initial state. An HTTP exchange is a single response to a single request. See Raxx.Server for details on implementing a valid module. A worker must be started for each message sent. Even if messages are sent on a single connection, e.g. HTTP pipelining or HTTP/2 streams."},{"ref":"Ace.HTTP.Worker.html#start_link/2","title":"Ace.HTTP.Worker.start_link/2","type":"function","doc":"Start a new worker linked to the calling process."},{"ref":"Ace.HTTP1.Parser.html","title":"Ace.HTTP1.Parser","type":"module","doc":"Incrementally parse an HTTP/1.x request."},{"ref":"Ace.HTTP1.Parser.html#done?/1","title":"Ace.HTTP1.Parser.done?/1","type":"function","doc":"Has the parser consumed and entire HTTP message?"},{"ref":"Ace.HTTP1.Parser.html#new/1","title":"Ace.HTTP1.Parser.new/1","type":"function","doc":"Initial state for the incremental parser."},{"ref":"Ace.HTTP1.Parser.html#parse/3","title":"Ace.HTTP1.Parser.parse/3","type":"function","doc":"Run the parser aginst a some new input. This parser returns a list of parts that are in the input and an updated state."},{"ref":"Ace.HTTP1.Parser.html#t:option/0","title":"Ace.HTTP1.Parser.option/0","type":"type","doc":"Available options when initializing a new parser"},{"ref":"Ace.HTTP1.Parser.html#t:state/0","title":"Ace.HTTP1.Parser.state/0","type":"opaque","doc":"State tracking the progress of the Parser."},{"ref":"Ace.HTTP2.html","title":"Ace.HTTP2","type":"module","doc":"Hypertext Transfer Protocol Version 2 (HTTP/2) HTTP/2 enables a more efficient use of network resources and a reduced perception of latency by introducing header field compression and allowing multiple concurrent exchanges on the same connection. It also introduces unsolicited push of representations from servers to clients. Quote from rfc 7540."},{"ref":"Ace.HTTP2.html#headers_to_request/2","title":"Ace.HTTP2.headers_to_request/2","type":"function","doc":"Build a Raxx.Request from a decoded list of headers. Note the required pseudo-headers must be first. Request pseudo-headers are; :scheme, :authority, :method &amp; :path. Duplicate or missing pseudo-headers will return an error."},{"ref":"Ace.HTTP2.html#headers_to_response/2","title":"Ace.HTTP2.headers_to_response/2","type":"function","doc":"Build a Raxx.Response from a decoded list of headers. Note the required pseudo-headers must be first. Response pseudo-headers are; :status. Duplicate or missing pseudo-headers will return an error."},{"ref":"Ace.HTTP2.html#headers_to_trailers/1","title":"Ace.HTTP2.headers_to_trailers/1","type":"function","doc":"Transform a list of decoded headers to a trailers structure. Note there are no required headers in a trailers set."},{"ref":"Ace.HTTP2.html#ping/2","title":"Ace.HTTP2.ping/2","type":"function","doc":"Send a ping frame over an HTTP/2 connection."},{"ref":"Ace.HTTP2.html#request_to_headers/1","title":"Ace.HTTP2.request_to_headers/1","type":"function","doc":"Transform an Raxx.Request into a generic headers list. This headers list can be encoded via Ace.HPack."},{"ref":"Ace.HTTP2.html#response_to_headers/1","title":"Ace.HTTP2.response_to_headers/1","type":"function","doc":"Transform a Raxx.Response into a generic headers list. This headers list can be encoded via Ace.HPack."},{"ref":"Ace.HTTP2.html#send/2","title":"Ace.HTTP2.send/2","type":"function","doc":""},{"ref":"Ace.HTTP2.Client.html","title":"Ace.HTTP2.Client","type":"module","doc":"Send requests via HTTP/2 to a web service. NB: all examples have this module aliased alias Ace.HTTP2.Client Establish connection To make requests, a client must have an open connection to the server. A client process is started to manage this connection. {:ok, client} = Client.start_link(&quot;http2.golang.org&quot;) # OR {:ok, client} = Client.start_link({&quot;http2.golang.org&quot;, 443}) Ace.HTTP2 only supports communication over TLS. It will attempt open a TLS connection for all port values. Reliable connections When a connection is lost the client process terminates. A reliable connection can be achieved by supervising the client process. children = [ worker(Client, [&quot;http2.golang.org&quot;, [name: MyApp.Client]]) ] A supervised client should be referenced by name. Opening a stream Sending a request will automatically open a new stream. The request consists of the headers to send and if it has a body. If the body is false or included in the request as a binary, the stream will be half_closed(local) once request is sent. A client will accept a request with a binary value for the body. In this case the body is assumed complete with no further data to stream {:ok, stream} = Client.stream(client) request = Raxx.request(:GET, &quot;/&quot;) |&gt; Raxx.set_header(&quot;accept&quot;, &quot;application/json&quot;) :ok = Ace.HTTP2.send(stream, request) {:ok, stream} = Client.stream(client) request = Raxx.request(:POST, &quot;/&quot;) |&gt; Raxx.set_header(&quot;content-length&quot;, &quot;13&quot;) |&gt; Raxx.set_body(&quot;Hello, World!&quot;) :ok = Ace.HTTP2.send(stream, request) request = Raxx.request(:POST, &quot;/&quot;) |&gt; Raxx.set_header(&quot;content-length&quot;, &quot;13&quot;) |&gt; Raxx.set_body(true) :ok = Ace.HTTP2.send(stream, request) data = Raxx.data(&quot;Hello, World!&quot;) {:ok, _} = Ace.HTTP2.send(stream, data) Receiving a response All data sent from the server if forwarded to the stream owner. The owner is the process that initiated the stream. receive do {^stream, %Raxx.Response{body: true}} -&gt; :ok end receive do {^stream, %Raxx.Data{data: &quot;Hello, World!&quot;}} -&gt; :ok end Response bodies will always be sent as separate messages to the stream owner. A complete response may be built using the collect_response/1 {:ok, %Raxx.Response{status: 200, body: &quot;Hello, World!&quot;}} = Client.collect_response(stream) Simple request response The Ace.Client aims to make the asynchronous stream of data easy. If this is not needed a synchronous interface is provided. {:ok, response} = Client.send_sync(connection, request) Examples See the client tests for more examples."},{"ref":"Ace.HTTP2.Client.html#collect_response/1","title":"Ace.HTTP2.Client.collect_response/1","type":"function","doc":"Collect all the parts streamed to a client as a single response."},{"ref":"Ace.HTTP2.Client.html#send_sync/2","title":"Ace.HTTP2.Client.send_sync/2","type":"function","doc":"Send a complete request and wait for a complete response. NOTE the request must have have body as a binary or false."},{"ref":"Ace.HTTP2.Client.html#start_link/2","title":"Ace.HTTP2.Client.start_link/2","type":"function","doc":"Start a new client to establish connection with server. Authority consists of the combination of {host, port}"},{"ref":"Ace.HTTP2.Client.html#stop/1","title":"Ace.HTTP2.Client.stop/1","type":"function","doc":"Close the connection established by a client."},{"ref":"Ace.HTTP2.Client.html#stream/1","title":"Ace.HTTP2.Client.stream/1","type":"function","doc":"Start a new stream within a running connection. Stream will start in idle state."},{"ref":"Ace.HTTP2.Frame.html","title":"Ace.HTTP2.Frame","type":"module","doc":"Basic protocol unit of HTTP/2. All frames begin with a fixed 9-octet header followed by a variable- length payload. +-----------------------------------------------+ | Length (24) | +---------------+---------------+---------------+ | Type (8) | Flags (8) | +-+-------------+---------------+-------------------------------+ |R| Stream Identifier (31) | +=+=============================================================+ | Frame Payload (0...) ... +---------------------------------------------------------------+"},{"ref":"Ace.HTTP2.Frame.html#decode/1","title":"Ace.HTTP2.Frame.decode/1","type":"function","doc":""},{"ref":"Ace.HTTP2.Frame.html#pad_data/2","title":"Ace.HTTP2.Frame.pad_data/2","type":"function","doc":"Add padding to a frames data"},{"ref":"Ace.HTTP2.Frame.html#parse/2","title":"Ace.HTTP2.Frame.parse/2","type":"function","doc":""},{"ref":"Ace.HTTP2.Frame.html#remove_padding/1","title":"Ace.HTTP2.Frame.remove_padding/1","type":"function","doc":"Remove the padding from the payload of a frame"},{"ref":"Ace.HTTP2.Frame.html#serialize/1","title":"Ace.HTTP2.Frame.serialize/1","type":"function","doc":"Transform HTTP2 frame to binary that can be transmitted over connection"},{"ref":"Ace.HTTP2.Frame.html#t:flags/0","title":"Ace.HTTP2.Frame.flags/0","type":"type","doc":""},{"ref":"Ace.HTTP2.Frame.html#t:stream_id/0","title":"Ace.HTTP2.Frame.stream_id/0","type":"type","doc":""},{"ref":"Ace.HTTP2.Frame.html#t:t/0","title":"Ace.HTTP2.Frame.t/0","type":"type","doc":""},{"ref":"Ace.Socket.html","title":"Ace.Socket","type":"module","doc":"Wrapper to normalise interactions with tcp or tls sockets. NOTE: tls sockets use the :ssl module and are identified with :ssl atom"},{"ref":"Ace.Socket.html#accept/1","title":"Ace.Socket.accept/1","type":"function","doc":""},{"ref":"Ace.Socket.html#negotiated_protocol/1","title":"Ace.Socket.negotiated_protocol/1","type":"function","doc":""},{"ref":"Ace.Socket.html#port/1","title":"Ace.Socket.port/1","type":"function","doc":""},{"ref":"Ace.Socket.html#send/2","title":"Ace.Socket.send/2","type":"function","doc":""},{"ref":"Ace.Socket.html#set_active/1","title":"Ace.Socket.set_active/1","type":"function","doc":""},{"ref":"Ace.Socket.html#t:listen_socket/0","title":"Ace.Socket.listen_socket/0","type":"type","doc":"Wrapped listen socket."},{"ref":"Ace.Socket.html#t:t/0","title":"Ace.Socket.t/0","type":"type","doc":"Wrapped tcp socket or tls socket."},{"ref":"readme.html","title":"Ace","type":"extras","doc":"Ace HTTP web server and client, supports http1 and http2 Install from Hex Documentation available on hexdoc Discuss on slack See Raxx.Kit for a project generator that helps you set up a web project based on Raxx/Ace."},{"ref":"readme.html#get-started","title":"Ace - Get started","type":"extras","doc":"Hello, World! defmodule MyApp do use Ace.HTTP.Service, port: 8080, cleartext: true use Raxx.SimpleServer @impl Raxx.SimpleServer def handle_request(%{method: :GET, path: []}, %{greeting: greeting}) do response(:ok) |&gt; set_header(&quot;content-type&quot;, &quot;text/plain&quot;) |&gt; set_body(&quot;\#{greeting}, World!&quot;) end end The arguments given to use Ace.HTTP.Service are default values when starting the service. Start the service config = %{greeting: &quot;Hello&quot;} MyApp.start_link(config, port: 1234) Here the default port value has been overridden at startup Raxx Ace implements the Raxx HTTP interface. This allows applications to be built with any components from the Raxx ecosystem. Raxx has tooling for streaming, server-push, routing, api documentation and more. See documentation for details. The correct version of raxx is included with ace, raxx does not need to be added as a dependency. TLS/SSL If a service is started without the cleartext it will start using TLS. This requires a certificate and key. config = %{greeting: &quot;Hello&quot;} options = [port: 8443, certfile: &quot;path/to/certificate&quot;, keyfile: &quot;path/to/key&quot;] MyApp.start_link(application, options) TLS is required to serve content via HTTP/2. Supervising services The normal way to run services is as part of a projects supervision tree. When starting a new project use the --sup flag. mix new my_app --sup Add the services to be supervised in the application file lib/my_app/application.ex. defmodule MyApp.Application do @moduledoc false use Application def start(_type, _args) do import Supervisor.Spec, warn: false children = [ {MyApp, [%{greeting: &quot;Hello&quot;}]} ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end end Start project using iex -S mix and visit http://localhost:8080."},{"ref":"readme.html#testing","title":"Ace - Testing","type":"extras","doc":"Run h2spec against the example hello_http2 application. Start the example app. cd examples/hello_http2 iex -S mix Run h2spec from docker sudo docker run --net=&quot;host&quot; summerwind/h2spec --port 8443 -t -k -S"}]